local menus = {}
local buttonStyle = "MainMenuButton"
local smallStyle = "MainMenuButtonSmall"

local function defaults( entry, menu )
	entry.ControlName = entry.ControlName or "BaseModHybridButton"
	entry.wide = 500
	entry.tall = 128
	entry.autoResize = 0
	entry.pinCorner = 0
	entry.visible = 1
	entry.enabled = 1
	entry.tabPosition = 0 -- does this do anything??
	entry.labelText = entry.labelText or "wtf dude"
	-- entry.style = entry.style or menu.buttonStyle or buttonStyle
	entry.ActivationType = 1
	entry.defaultFgColor_override = entry.color or "255 255 255 255"
	entry.armedFgColor_override = entry.defaultFgColor_override
	entry.depressedFgColor_override = entry.defaultFgColor_override
	entry.keyboardFocusColor_override = entry.defaultFgColor_override
	entry.color = nil

	-- shithack
	entry.xpos_nonwide = ( entry.xpos_nonwide or entry.xpos_wide or entry.xpos ) - 45

	return entry
end

local x = 35 * 2.75

menus[ "credits" ] =
{
	{ labelText = "For R.", xpos = x, ypos = 132, style = "CreditsHuge", fadeInFrom = 1.97, fadeInTo = 3.27, fadeOutFrom = 11.50, fadeOutTo = 12.80 },
	{ labelText = "#UI_CreditsLine02", xpos = x, ypos = 127, style = "CreditsHeading", fadeInFrom = 14.17, fadeInTo = 15.77, fadeOutFrom = 24.17, fadeOutTo = 25.13 },
	{ labelText = "#UI_CreditsLine12", xpos = x, ypos = 167 - 50, style = "CreditsHeading", fadeInFrom = 37.13, fadeInTo = 38.1, fadeOutFrom = 49.6, fadeOutTo = 50.57 },
	{ labelText = "#UI_CreditsLine08", xpos = x - 7, ypos = 167, style = "CreditsHeading", fadeInFrom = 26.3, fadeInTo = 27.27, fadeOutFrom = 34.83, fadeOutTo = 35.8 }
}

local names = {}
names[ 3 ] =
{
	{ "#UI_CreditsLine09" },
	{ "#UI_CreditsLine10" }
}

names[ 1 ] = 
{
	{ "Matthew Breit", "Jes\195\186s Higueras" },
	{ "Ryan Roth", "Lydia Nelson" },
	{ "Halina Heron", "Jack Parsons" },
	{ "Richard Flanagan", "Andreas J\195\182rgensen" }
}

names[ 2 ] = 
{
	{ "Aviva Pinchas", "James Renovich", "Rusty Moyher" },
	{ "Chaille Stidham", "Jenny Bazan", "Sam Mularczyk" },
	{ "Eduardo Ortiz", "Matt Piersall", "Samantha Kalman" },
	{ "Felix Kramer", "Mattie Brice", "Tim Grant" },
	{ "Gabriele Brombin", "Nathan Black", "Victoria Tyler" },
	{ "George Royer", "Rami Ismail", "William Pugh" },
	{ "James Portnow", "Robin Arnott", "Zak Ayles" }
}

for screen = 1, #names do
	for xx = 1, #names[ screen ][ 1 ] do
		for yy = 1, #names[ screen ] do
			local xpos = x + ( xx - 1 ) * 220
			local xpos_nonwide = x + ( xx - 1 ) * 180
			local ypos = 127 + 90 + ( yy - 1 ) * ( screen == 3 and 28 or 31 )

			local fadeInFrom, fadeInTo, fadeOutFrom, fadeOutTo
			if screen == 1 then
				fadeInFrom = 16.0
				fadeInTo = 17.7
				fadeOutFrom = 23.77
				fadeOutTo = 24.73
			elseif screen == 3 then
				fadeInFrom = 27.97
				fadeInTo = 29.43
				fadeOutFrom = 34.23
				fadeOutTo = 35.2
			elseif screen == 2 then
				ypos = ypos - 50
				if xx == 1 then
					fadeInFrom = 38.63
					fadeInTo = 39.63
					fadeOutFrom = 48.97
					fadeOutTo = 49.93
				elseif xx == 2 then
					fadeInFrom = 40.27
					fadeInTo = 41.27
					fadeOutFrom = 48.97
					fadeOutTo = 49.93
				elseif xx == 3 then
					fadeInFrom = 41.8
					fadeInTo = 42.8
					fadeOutFrom = 48.97
					fadeOutTo = 49.93
				end
			end
			table.insert( menus.credits, { labelText = names[ screen ][ yy ][ xx ], color = "188 182 143 255", xpos_wide = xpos, xpos_nonwide = xpos_nonwide, ypos = ypos, style_wide = "CreditsName", style_nonwide = "CreditsNameSmall", fadeInFrom = fadeInFrom, fadeInTo = fadeInTo, fadeOutFrom = fadeOutFrom, fadeOutTo = fadeOutTo } )
		end
	end
end

for name, menu in pairs( menus ) do
	local f = io.open( name .. ".res", "w" )
	f:write( '"resource/ui/' .. name .. '.res"\n{' )

	f:write( string.format( [[

	"%s"
	{
		"fieldName"	"%s"
		"xpos"	"0"
		"ypos"	"0"
		"wide"	"f0"
		"tall"	"f0"
		"autoResize"	"0"
		"pinCorner"	"0"
		"visible"	"1"
		"enabled"	"1"
		"tabPosition"	"0"
		"PaintBackgroundType"	"0"
		"dialogstyle"	"1"
	}
]], name, name ) )

	-- Add position and other copy paste shit that doesn't rely on other buttons/entries/whatever
	for i, entry in pairs( menu ) do
		if type( entry ) == "table" then
			defaults( entry, menu )
			entry.fieldName = i - 1
		end
	end

	-- Add navUp/navDown
	for i, entry in pairs( menu ) do
		if type( entry ) == "table" then
			local upper = menu[ i - 1 ] or menu[ #menu ]
			local lower = menu[ i + 1 ] or menu[ 1 ]
			entry.navUp = upper.fieldName
			entry.navDown = lower.fieldName

			f:write( string.format( '\n\t"%s"\n\t{', entry.fieldName ) )
			for k, v in pairs( entry ) do
				if not entry.__absolute and not entry[ "__absolute_" .. k ] then
					if menu[ k .. "_prefix" ] then v = ( menu[ k .. "_prefix" ] .. v ):gsub( "%+%-", "-" ) end
				end

				if type( v ) == "table" then
					f:write( string.format( '\n\t\t"%s"\n\t\t{', k ) )
					for sk, sv in pairs( v ) do
						f:write( string.format( '\n\t\t\t"%s"		"%s"', sk, sv ) )
					end
					f:write( '\n\t\t}' )
				else
					local qualifier = ""
					if string.match( k, "_nonwide$" ) then
						k = k:gsub( "_nonwide$", "" )
						qualifier = "[!$WIN32WIDE]"
					elseif string.match( k, "_wide$" ) then
						k = k:gsub( "_wide$", "" )
						qualifier = "[$WIN32WIDE]"
					end

					f:write( string.format( '\n\t\t"%s"		"%s" %s', k, v, qualifier ) )
				end
			end
			f:write( string.format( '\n\t}\n' ) )
		end
	end

	f:write( '}' ) -- so this is why the console was vomiting errors

	f:close()
end