local menus = {}

local basex = -120
local basey = -30

local entryWide = 200
local entryTall = 32

local buttonStyle = "MainMenuButton"
local smallStyle = "MainMenuButtonSmall"

local function defaults( entry, menu )
	entry.ControlName = entry.ControlName or "BaseModHybridButton"
	entry.fieldName = ( entry.name or entry.command ) and ( "Btn" .. ( entry.name or entry.command ) ) or ( "UselessButton" .. i )
	entry.wide = entry.wide or entryWide
	entry.tall = entry.tall or entryTall
	entry.autoResize = 0
	entry.pinCorner = 0
	entry.visible = 1
	entry.enabled = 1
	entry.tabPosition = 0 -- does this do anything??
	entry.labelText = entry.labelText or "wtf dude"
	entry.style = entry.style or menu.buttonStyle or buttonStyle
	entry.ActivationType = 1

	return entry
end

menus[ "mainmenu_tsp" ] = {
	{ labelText = "#UI_BeginGame", command = "SoloPlay" },
	{ labelText = "#UI_ChapterSelect", command = "ChapterSelect" },
	{ labelText = "#UI_Options", command = "Options" },
	{ labelText = "#UI_Quit", command = "QuitGame_NoConfirm" },
	xpos_prefix = "c+",
	ypos_prefix = "c+"
}

menus[ "options" ] = {
	{ labelText = "#UI_Audio", command = "Audio" },
	{ labelText = "#UI_Video", command = "Video" },
	{ labelText = "#UI_KBM", command = "KeyboardMouse" },
	{ labelText = "#UI_BackUpper", command = "Back", __absolute_ypos = true, ypos = 480 - entryTall * 2.5, style = smallStyle },
	xpos_prefix = "c+",
	ypos_prefix = "c+",
	basey = -30 - entryTall * 1.3
}

-- exporting these is bad because they were manually tweaked

--[[menus[ "audio" ] = {
	{ labelText = "#UI_Volume", name = "Volume" },
	{ labelText = "#UI_MusicVolume", name = "MusicVolume" },
	{ labelText = "#UI_SpeakerConfiguration", name = "Speakers", style = "DialogListButton" },
	{ labelText = "#UI_SoundQuality", name = "Quality", style = "DialogListButton" },
	{ labelText = "#UI_Caption_Proper", name = "Captioning", style = "DialogListButton" },
	{ labelText = "#UI_ApplyUpper", name = "OK", command = "Apply", __absolute_ypos = true, ypos = 480 - entryTall * 2.5, style = smallStyle }, -- needs to be named "OK" because hardcode
	{ labelText = "#UI_BackUpper", command = "Back", __absolute_ypos = true, ypos = 480 - entryTall * 2.5, xpos = basex + 20, style = smallStyle },
	xpos_prefix = "c+",
	ypos_prefix = "c+",
	basey = -30 - entryTall * 2.3
}]]

for name, menu in pairs( menus ) do
	local f = io.open( name .. ".res", "w" )
	f:write( '"resource/ui/' .. name .. '.res"\n{' )

	f:write( string.format( [[

	"%s"
	{
		"fieldName"	"%s"
		"xpos"	"0"
		"ypos"	"0"
		"wide"	"f0"
		"tall"	"f0"
		"autoResize"	"0"
		"pinCorner"	"0"
		"visible"	"1"
		"enabled"	"1"
		"tabPosition"	"0"
		"PaintBackgroundType"	"0"
		"dialogstyle"	"1"
	}
]], name, name ) )

	local x = menu.basex or basex
	local y = menu.basey or basey

	-- Add position and other copy paste shit that doesn't rely on other buttons/entries/whatever
	for i, entry in pairs( menu ) do
		if type( entry ) == "table" then
			defaults( entry, menu )
			entry.xpos = entry.xpos or x
			entry.ypos = entry.ypos or y
			y = y + entry.tall
		end
	end

	-- Add navUp/navDown
	for i, entry in pairs( menu ) do
		if type( entry ) == "table" then
			local upper = menu[ i - 1 ] or menu[ #menu ]
			local lower = menu[ i + 1 ] or menu[ 1 ]
			entry.navUp = upper.fieldName
			entry.navDown = lower.fieldName

			f:write( string.format( '\n\t"%s"\n\t{', entry.fieldName ) )
			for k, v in pairs( entry ) do
				if not entry.__absolute and not entry[ "__absolute_" .. k ] then
					if menu[ k .. "_prefix" ] then v = ( menu[ k .. "_prefix" ] .. v ):gsub( "%+%-", "-" ) end
				end

				if type( v ) == "table" then
					f:write( string.format( '\n\t\t"%s"\n\t\t{', k ) )
					for sk, sv in pairs( v ) do
						f:write( string.format( '\n\t\t\t"%s"		"%s"', sk, sv ) )
					end
					f:write( '\n\t\t}' )
				else
					f:write( string.format( '\n\t\t"%s"		"%s"', k, v ) )
				end
			end
			f:write( string.format( '\n\t}\n' ) )
		end
	end

	f:write( '}' ) -- so this is why the console was vomiting errors

	f:close()
end